#ifndef MYX_MATH_ALMOST_EQUAL_ULPS_HPP_
#define MYX_MATH_ALMOST_EQUAL_ULPS_HPP_

#pragma once

#include <myx/base/config.hpp>
#include <myx/math/float_cmp_types.hpp>

#include <cmath>

namespace myx {

namespace math {

/**
 * @brief Проверка на равенство двух аргументов типа float.
 *        Параметр maxUlpsDiff определяет максимальную разницу между аргументами,
 *        при которой они считаются равными.
 */
bool almost_equal_ulps( float a, float b,
                        int maxUlpsDiff );
/**
 * @brief Проверка на равенство двух аргументов типа double.
 *        Параметр maxUlpsDiff определяет максимальную разницу между аргументами,
 *        при которой они считаются равными.
 */
bool almost_equal_ulps( double a, double b,
                        int maxUlpsDiff );

} // namespace math

} // namespace myx

#ifdef MYXLIB_HEADER_ONLY
#include "almost_equal_ulps-inl.hpp"
#endif

#endif // MYX_MATH_ALMOST_EQUAL_ULPS_HPP_
